Skip site navigation (1)Skip section navigation (2)
Date:      Wed, 6 Nov 2024 23:29:11 GMT
From:      Dimitry Andric <dim@FreeBSD.org>
To:        src-committers@FreeBSD.org, dev-commits-src-all@FreeBSD.org, dev-commits-src-branches@FreeBSD.org
Subject:   git: d4cfad2d0391 - stable/13 - amd64: do not pass -z rodynamic to ld.bfd when building vdso
Message-ID:  <202411062329.4A6NTBbr053782@gitrepo.freebsd.org>

next in thread | raw e-mail | index | archive | help
The branch stable/13 has been updated by dim:

URL: https://cgit.FreeBSD.org/src/commit/?id=d4cfad2d0391d0bb306d24d1fbcb4ba72078b328

commit d4cfad2d0391d0bb306d24d1fbcb4ba72078b328
Author:     Konstantin Belousov <kib@FreeBSD.org>
AuthorDate: 2024-10-18 14:09:26 +0000
Commit:     Dimitry Andric <dim@FreeBSD.org>
CommitDate: 2024-11-06 23:24:38 +0000

    amd64: do not pass -z rodynamic to ld.bfd when building vdso
    
    (cherry picked from commit 3b2cf9381ef86847603c3c94811f638660c417ae)
---
 sys/tools/amd64_ia32_vdso.sh | 7 ++++++-
 sys/tools/amd64_vdso.sh      | 9 +++++++--
 2 files changed, 13 insertions(+), 3 deletions(-)

diff --git a/sys/tools/amd64_ia32_vdso.sh b/sys/tools/amd64_ia32_vdso.sh
index e64c964219c3..09e08dc05dd2 100644
--- a/sys/tools/amd64_ia32_vdso.sh
+++ b/sys/tools/amd64_ia32_vdso.sh
@@ -34,9 +34,14 @@ ${CC} -x assembler-with-cpp -DLOCORE -fPIC -nostdinc -c -m32 \
    -o ia32_sigtramp.pico -I. -I"${S}" -include opt_global.h \
    "${S}"/amd64/ia32/ia32_sigtramp.S
 
+if ${LD} --version | ${AWK} '/^GNU ld/{exit 1}' ; then
+    RODYNAMIC="-z rodynamic"
+else
+    RODYNAMIC=""
+fi
 ${LD} --shared -Bsymbolic -soname="elf-vdso32.so.1" \
    -T "${S}"/conf/vdso_amd64_ia32.ldscript \
-   --eh-frame-hdr --no-undefined -z rodynamic -z norelro -nmagic \
+   --eh-frame-hdr --no-undefined ${RODYNAMIC} -z norelro -nmagic \
    --hash-style=sysv --fatal-warnings --strip-all \
    -o elf-vdso32.so.1 ia32_sigtramp.pico
 
diff --git a/sys/tools/amd64_vdso.sh b/sys/tools/amd64_vdso.sh
index 1a0203e3e0a4..295b16c87c2d 100644
--- a/sys/tools/amd64_vdso.sh
+++ b/sys/tools/amd64_vdso.sh
@@ -40,12 +40,17 @@ ${CC} -x assembler-with-cpp -DLOCORE -fPIC -nostdinc -c \
 #
 # -z rodynamic is undocumented lld-specific option, seemingly required
 # for lld to avoid putting dynamic into dedicated writeable segment,
-# despite ldscript placement.  It is ignored by ld.bfd but ldscript
+# despite ldscript placement.  It is omitted for ld.bfd, but ldscript
 # alone is enough there.
 #
+if ${LD} --version | ${AWK} '/^GNU ld/{exit 1}' ; then
+    RODYNAMIC="-z rodynamic"
+else
+    RODYNAMIC=""
+fi
 ${LD} --shared -Bsymbolic -soname="elf-vdso.so.1" \
    -T "${S}"/conf/vdso_amd64.ldscript \
-   --eh-frame-hdr --no-undefined -z rodynamic -z norelro -nmagic \
+   --eh-frame-hdr --no-undefined ${RODYNAMIC} -z norelro -nmagic \
    --hash-style=sysv --fatal-warnings --strip-all \
    -o elf-vdso.so.1 sigtramp.pico
 



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?202411062329.4A6NTBbr053782>